"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var operation_1 = require("../operation");
var util_1 = require("../util");
var universal_connector_mapper_1 = require("../component/connector/universal-connector.mapper"); // Move to util?
/**
 * @stable [17.01.2019]
 * @param {TEntity} changes
 * @param {TEntity} entity
 * @param {TEntity} originalEntity
 * @param {string} operationId
 * @returns {IApiEntity<TEntity extends IEntity>}
 */
exports.apiEntityFactory = function (changes, entity, originalEntity, operationId) {
    var entityId = entity && entity.id;
    var merger = __assign({}, entity, changes);
    var copiedChanges = __assign({}, changes);
    var apiEntity = (R.isNil(entityId)
        ? { isNew: true, changes: copiedChanges, merger: merger }
        : util_1.defValuesFilter({
            isNew: false,
            id: entityId,
            changes: copiedChanges,
            merger: merger,
            entity: universal_connector_mapper_1.simpleEntityMapper(entity),
            originalEntity: universal_connector_mapper_1.simpleEntityMapper(originalEntity),
        }));
    return __assign({ operation: operation_1.Operation.create(operationId) }, apiEntity);
};
//# sourceMappingURL=api.support.js.map