import { IBasicConnectorConfiguration, IConnectorConfiguration } from '../../configurations-definitions.interface';
import { IUniversalContainerClassEntity, IUniversalApplicationStoreEntity } from '../../entities-definitions.interface';
import { IUniversalContainerProps } from '../../props-definitions.interface';
/**
 * @stable - 23.04.2018
 * @param {IBasicConnectorConfiguration<TStoreEntity>} config
 * @returns {(target: IContainerClassEntity) => void}
 */
export declare const basicConnector: <TStoreEntity extends IUniversalApplicationStoreEntity<{}>>(config: IBasicConnectorConfiguration<TStoreEntity>) => (target: IUniversalContainerClassEntity<IUniversalContainerProps, {}>) => void;
/**
 * @stable - 23.04.2018
 * @param {IConnectorConfiguration<TStoreEntity extends IUniversalApplicationStoreEntity, TAccessConfig>} config
 * @returns {(target: IContainerClassEntity) => void}
 */
export declare const connector: <TStoreEntity extends IUniversalApplicationStoreEntity<{}>, TAccessConfig>(config: IConnectorConfiguration<TStoreEntity, TAccessConfig>) => (target: IUniversalContainerClassEntity<IUniversalContainerProps, {}>) => void;
