import * as React from 'react';
import { BaseComponent } from '../base';
import { IUniversalDialog, IDialogProps, IUniversalDialogProps } from './dialog.interface';
export declare class Dialog<TComponent extends IUniversalDialog<TProps, TState> = IUniversalDialog<TProps, TState>, TProps extends IDialogProps = IDialogProps, TState = {}> extends BaseComponent<TComponent, TProps, TState> implements IUniversalDialog<TProps, TState> {
    static readonly defaultProps: IUniversalDialogProps;
    /**
     * @stable [04.10.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [03.08.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [17.05.2018]
     */
    activate(callback?: () => void): void;
    /**
     * @stable [17.05.2018]
     */
    onAccept(): void;
    /**
     * @stable [17.05.2018]
     */
    onClose(): void;
    /**
     * @stable [17.05.2018]
     * @returns {boolean}
     */
    readonly acceptable: boolean;
    /**
     * @stable [17.05.2018]
     * @returns {boolean}
     */
    readonly closable: boolean;
    /**
     * @stable [04.10.2018]
     * @returns {JSX.Element}
     */
    protected getDialogBody(): JSX.Element;
    /**
     * @stable [05.08.2018]
     * @returns {string}
     */
    protected getDialogClassName(): string;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    protected isCloseButtonDisabled(): boolean;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    protected isAcceptButtonDisabled(): boolean;
    /**
     * @stable [03.08.2018]
     * @returns {React.ReactNode}
     */
    protected getDialogBodyElement(): React.ReactNode;
    /**
     * @stable [04.08.2018]
     * @returns {boolean}
     */
    protected isDialogVisible(): boolean;
}
