import { AnyT, IKeyValue } from '../../../definitions.interface';
import { VueBaseComponent } from '../../base/vue-index';
import { VueCreateElementFactoryT, VueNodeT } from '../../../vue-definitions.interface';
import { IVueFieldTemplateComputedEntity, IVueFieldTemplateMethods, IVueFieldInputListenersEntity, IVueFieldState, IVueField, IVueFieldProps } from './vue-field.interface';
export declare class VueField<TStore = IKeyValue, TState extends IVueFieldState = IVueFieldState> extends VueBaseComponent<TStore, TState> implements IVueField, IVueFieldProps {
    value: AnyT;
    full: boolean;
    useLocalization: boolean;
    label: string;
    displayName: string;
    name: string;
    placeholder: string;
    protected type: string;
    protected floatLabel: boolean;
    protected icon: string;
    protected autoFocus: boolean;
    /**
     * @stable [17.11.2018]
     */
    constructor();
    /**
     * @stable [26.10.2018]
     */
    mounted(): void;
    /**
     * @stable [21.10.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    render(createElement: VueCreateElementFactoryT): VueNodeT;
    /**
     * @stable [17.11.2018]
     * @returns {Partial<HTMLInputElement>}
     */
    getInputBindings(): Partial<HTMLInputElement>;
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    getFieldClassName(): string;
    /**
     * @stable [17.11.2018]
     * @returns {IVueFieldInputListenersEntity}
     */
    getInputListeners(): IVueFieldInputListenersEntity;
    /**
     * @stable [17.11.2018]
     * @returns {boolean}
     */
    isInputWrapperFull(): boolean;
    /**
     * @stable [17.11.2018]
     * @returns {boolean}
     */
    isFieldFull(): boolean;
    /**
     * @stable [27.11.2018]
     * @returns {string}
     */
    getInputWrapperClassName(): string;
    /**
     * @stable [17.11.2018]
     * @returns {AnyT}
     */
    getValue(): AnyT;
    /**
     * @stable [21.10.2018]
     * @param {AnyT} newValue
     */
    onChange(newValue: AnyT): void;
    /**
     * @stable [28.11.2018]
     * @param newValue
     * @param {AnyT} context
     */
    onChangeManually(newValue: any, context?: AnyT): void;
    /**
     * @stable [20.12.2018]
     * @returns {TState}
     */
    getInitialData$(): TState;
    /**
     * @stable [19.01.2019]
     * @param {AnyT} newValue
     * @returns {AnyT}
     */
    protected toEmittedValue(newValue: AnyT): AnyT;
    /**
     * @stable [20.12.2018]
     * @param {AnyT} newValue
     * @returns {boolean}
     */
    protected canSetDataDisplayValueOnManualInputChange(newValue: AnyT): boolean;
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    protected getInputClassName(): string;
    /**
     * @stable [21.10.2018]
     * @returns {string}
     */
    protected getFieldAttachmentTemplate(): string;
    /**
     * @stable [18.11.2018]
     * @returns {string}
     */
    protected getInputAttachmentTemplate(): string;
    /**
     * @stable [22.10.2018]
     * @returns {string}
     */
    protected getLabelTemplate(): string;
    /**
     * @stable [24.11.2018]
     * @returns {boolean}
     */
    protected hasValue(): boolean;
    /**
     * @stable [10.12.2018]
     * @returns {AnyT}
     */
    protected getEmptyValue(): AnyT;
    /**
     * @stable [10.12.2018]
     * @returns {boolean}
     */
    protected hasFloatLabel(): boolean;
    /**
     * @stable [26.10.2018]
     * @returns {IVueFieldTemplateComputedEntity}
     */
    protected getTemplateComputed(): IVueFieldTemplateComputedEntity;
    /**
     * @stable [17.11.2018]
     * @returns {AnyT}
     */
    protected getDisplayValue(): AnyT;
    /**
     * @stable [21.12.2018]
     * @returns {AnyT}
     */
    protected getInputDisplayValue(): AnyT;
    /**
     * @stable [21.12.2018]
     * @param {AnyT} newValue
     * @returns {boolean}
     */
    protected isFieldChangedManually(newValue: AnyT): boolean;
    /**
     * @stable [26.10.2018]
     * @returns {HTMLInputElement}
     */
    protected readonly inputEl: HTMLInputElement;
    /**
     * @stable [17.11.2018]
     * @returns {HTMLInputElement}
     */
    protected readonly inputWrapperEl: HTMLInputElement;
    /**
     * @stable [26.10.2018]
     */
    protected setFocus(): void;
    /**
     * @stable [22.12.2018]
     * @returns {TMethods}
     */
    protected getTemplateMethods<TMethods extends IVueFieldTemplateMethods>(): TMethods;
    /**
     * @stable [20.12.2018]
     * @param {string} fieldName
     * @returns {AnyT}
     */
    protected fromStore(fieldName: string): AnyT;
}
