"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var R = require("ramda");
var util_1 = require("../../../util");
var vue_entities_definitions_interface_1 = require("../../../vue-entities-definitions.interface");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../textfield/vue-index");
var vue_select_interface_1 = require("./vue-select.interface");
var VueSelect = /** @class */ (function (_super) {
    __extends(VueSelect, _super);
    function VueSelect() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [21.10.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueSelect.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [17.11.2018]
     * @returns {IVueFieldInputListenersEntity}
     */
    VueSelect.prototype.getInputListeners = function () {
        return __assign({}, _super.prototype.getInputListeners.call(this), { click: this.onInputClick });
    };
    /**
     * @stable [21.10.2018]
     * @returns {string}
     */
    VueSelect.prototype.getFieldClassName = function () {
        return _super.prototype.getFieldClassName.call(this) + " vue-select";
    };
    /**
     * @stable [17.11.2018]
     * @param {IMenuItemEntity} option
     */
    VueSelect.prototype.onSelect = function (option) {
        this.getData().displayValue = option.rawData && option.rawData.name || option.label;
        this.onChange(option.value);
        this.$emit('select', option);
    };
    /**
     * @stable [21.12.2018]
     * @returns {IVueMenuProps}
     */
    VueSelect.prototype.getMenuBindings = function () {
        return __assign({}, this.menuProps, { options: this.getOptions() });
    };
    /**
     * @stable [21.12.2018]
     */
    VueSelect.prototype.onIconClick = function () {
        this.onInputClick();
    };
    /**
     * @stable [22.12.2018]
     * @returns {TMethods}
     */
    VueSelect.prototype.getTemplateMethods = function () {
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { onSelect: this.onSelect, getMenuBindings: this.getMenuBindings });
    };
    /**
     * @stable [20.12.2018]
     * @param {StringNumberT} newValue
     * @returns {boolean}
     */
    VueSelect.prototype.canSetDataDisplayValueOnManualInputChange = function (newValue) {
        return this.isFieldChangedManually(newValue);
    };
    /**
     * @stable [18.11.2018]
     * @returns {string}
     */
    VueSelect.prototype.getInputAttachmentTemplate = function () {
        return "<vue-menu ref=\"menu\"\n                      @select=\"onSelect($event)\"\n                      v-bind=\"getMenuBindings()\"/>";
    };
    /**
     * @stable [25.12.2018]
     * @returns {ISelectOptionEntity[]}
     */
    VueSelect.prototype.getOptions = function () {
        var _this = this;
        var currentValue = this.getValue();
        var areChangesPresent = !R.isEmpty(currentValue) && this.isFieldChangedManually(currentValue);
        var options = this.options;
        return util_1.isArrayNotEmpty(options)
            ? (areChangesPresent
                ? (R.filter(function (option) { return _this.filter(option, currentValue); }, options)
                    .map(function (option) {
                    return (__assign({}, option, { label: util_1.strongHtmlReplace(option.label || option.value, currentValue) }));
                }))
                : R.filter(function (option) { return option.value !== currentValue; }, options))
            : options;
    };
    /**
     * @stable [20.12.2018]
     * @param {StringNumberT} newValue
     * @returns {boolean}
     */
    VueSelect.prototype.isFieldChangedManually = function (newValue) {
        return util_1.isString(newValue);
    };
    /**
     * @stable [18.11.2018]
     */
    VueSelect.prototype.onInputClick = function () {
        this.getMenu().show({ width: util_1.getWidth(this.inputWrapperEl) });
        if (this.isContainerBound() && util_1.isString(this.bindDictionary)) {
            this.bindContainer.dispatchLoadDictionary(this.bindDictionary);
        }
        this.$emit('show');
    };
    /**
     * @stable [17.11.2018]
     * @returns {IVueMenu}
     */
    VueSelect.prototype.getMenu = function () {
        return this.getChildrenRefs().menu;
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueSelect.prototype, "bindDictionary", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueSelect.prototype, "menuProps", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'vue-icon-expand'; } }),
        __metadata("design:type", String)
    ], VueSelect.prototype, "icon", void 0);
    __decorate([
        vue_property_decorator_1.Prop({
            default: function () { return function (option, query) {
                return String((option.label || option.value)).toLowerCase().includes(query.toLowerCase());
            }; },
        }),
        __metadata("design:type", Function)
    ], VueSelect.prototype, "filter", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Array)
    ], VueSelect.prototype, "options", void 0);
    VueSelect = __decorate([
        vue_index_1.ComponentName(vue_select_interface_1.VUE_SELECT_NAME),
        vue_property_decorator_1.Component(vue_entities_definitions_interface_1.vueDefaultComponentConfigFactory())
    ], VueSelect);
    return VueSelect;
}(vue_index_2.VueBaseTextField));
//# sourceMappingURL=vue-select.component.js.map