"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var configurations_definitions_interface_1 = require("../../configurations-definitions.interface");
/**
 * @stable [08.05.2018]
 */
exports.KEYBOARD_SPECIAL_KEYS = {
    UPPERCASE: '↑',
    LOWERCASE: '↓',
    BACK: '‹',
    SPACE: ' ',
    DIGITAL: '123',
    LITERAL: 'ABC',
};
/**
 * @stable [08.05.2018]
 */
exports.KEYBOARD_QWERTY_LAYOUT = [
    ['q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p'],
    ['a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l'],
    [{ value: exports.KEYBOARD_SPECIAL_KEYS.UPPERCASE, type: configurations_definitions_interface_1.KeyboardKeyEnum.UPPERCASE },
        'z', 'x', 'c', 'v', 'b', 'n', 'm',
        { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: configurations_definitions_interface_1.KeyboardKeyEnum.BACKSPACE }],
    [
        { value: exports.KEYBOARD_SPECIAL_KEYS.DIGITAL, type: configurations_definitions_interface_1.KeyboardKeyEnum.CHANGE_LAYOUT },
        ',',
        { value: exports.KEYBOARD_SPECIAL_KEYS.SPACE, type: configurations_definitions_interface_1.KeyboardKeyEnum.SPACE, width: 200 },
        '.'
    ]
];
/**
 * @stable [08.05.2018]
 */
exports.KEYBOARD_QWERTY_DIGITAL_LAYOUT = [
    ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'],
    ['!', '@', '#', '$', '%', '&', '+', '?', '/'],
    ['*', '_', '"', '\'', '(', ')', '-', ':', { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: configurations_definitions_interface_1.KeyboardKeyEnum.BACKSPACE }],
    [{ value: exports.KEYBOARD_SPECIAL_KEYS.LITERAL, type: configurations_definitions_interface_1.KeyboardKeyEnum.CHANGE_LAYOUT },
        ';', ',', { value: exports.KEYBOARD_SPECIAL_KEYS.SPACE, type: configurations_definitions_interface_1.KeyboardKeyEnum.SPACE, width: 200 }, '.', '=']
];
/**
 * @stable [21.11.2018]
 */
exports.KEYBOARD_NUMERIC_LAYOUT = [
    ['1', '2', '3', '4', '5'],
    ['6', '7', '8', '9', '0'],
    ['+', '-', ',', '.', { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: configurations_definitions_interface_1.KeyboardKeyEnum.BACKSPACE }]
];
/**
 * @stable [13.01.2019]
 */
exports.KEYBOARD_BASIC_NUMERIC_LAYOUT = [
    ['1', '2', '3'],
    ['4', '5', '6'],
    ['7', '8', '9'],
    ['.', '0', { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: configurations_definitions_interface_1.KeyboardKeyEnum.BACKSPACE }]
];
//# sourceMappingURL=keyboard.interface.js.map