"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var universal_list_component_1 = require("./universal-list.component");
var rn_list_item_component_1 = require("./item/rn-list-item.component");
var rn_message_component_1 = require("../message/rn-message.component");
var rn_button_component_1 = require("../button/rn-button.component");
var RnList = /** @class */ (function (_super) {
    __extends(RnList, _super);
    function RnList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [09.06.2018]
     * @returns {JSX.Element}
     */
    RnList.prototype.getEmptyMessageAction = function () {
        return React.createElement(rn_button_component_1.RnButton, __assign({}, this.getEmptyMessageActionComponentProps()));
    };
    /**
     * @stable [09.06.2018]
     * @returns {JSX.Element}
     */
    RnList.prototype.getMessage = function () {
        return (React.createElement(rn_message_component_1.RnMessage, __assign({}, this.getMessageComponentProps()), this.getAddAction()));
    };
    /**
     * @stable - 24.04.2018
     * @returns {JSX.Element}
     */
    RnList.prototype.getView = function () {
        var _this = this;
        return (React.createElement(react_native_1.FlatList, { ref: 'container', data: this.dataSource.map(function (item) { return (__assign({}, item, { key: String(item.id) })); }), renderItem: function (_a) {
                var item = _a.item, separators = _a.separators;
                return _this.getItem(item, separators);
            } }, this.getAddAction()));
    };
    /**
     * @stable - 24.04.2018
     * @param {IEntity} entity
     * @param {IKeyValue} separators
     * @returns {JSX.Element}
     */
    RnList.prototype.getItem = function (entity, separators) {
        var _this = this;
        var props = this.props;
        var rowKey = this.toRowKey(entity);
        return (React.createElement(rn_list_item_component_1.RnListItem, __assign({ ref: rowKey, key: rowKey, rawData: entity, separators: separators, selected: this.isEntitySelected(entity), onClick: function () { return _this.onSelect(entity); } }, props.itemConfiguration)));
    };
    RnList.prototype.getAddAction = function () {
        // TODO
        return null;
    };
    return RnList;
}(universal_list_component_1.UniversalList));
exports.RnList = RnList;
//# sourceMappingURL=rn-list.component.js.map