"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ripple_1 = require("@material/ripple");
var checkbox_1 = require("@material/checkbox");
var switch_1 = require("@material/switch");
var di_1 = require("../../di");
var util_1 = require("../../util");
var field_1 = require("../field");
var plugin_1 = require("./plugin");
var factory_1 = require("./factory");
var menu_1 = require("../menu");
var tabpanel_1 = require("../tabpanel");
var card_1 = require("../card");
var keyboard_1 = require("../keyboard");
var dialog_1 = require("../dialog");
var form_1 = require("../form");
var snackbar_1 = require("../snackbar");
var uiPlugins = new Map();
/**
 * @stable [17.08.2018]
 */
uiPlugins.set(field_1.Checkbox, function (component) { return new plugin_1.MaterialPlugin(component, checkbox_1.MDCCheckbox); });
/**
 * @stable [31.08.2018]
 */
uiPlugins.set(field_1.Switch, function (component) { return new plugin_1.MaterialPlugin(component, switch_1.MDCSwitch); });
/**
 * @stable [15.08.2018]
 */
uiPlugins.set(tabpanel_1.TabPanel, function (component) { return new plugin_1.TabPanelMaterialPlugin(component); });
/**
 * @stable [15.08.2018]
 */
uiPlugins.set(snackbar_1.Snackbar, function (component) { return new plugin_1.SnackbarMaterialPlugin(component); });
/**
 * @stable [18.05.2018]
 */
uiPlugins.set(dialog_1.Dialog, function (component) { return new plugin_1.DialogMaterialPlugin(component); });
/**
 * @stable [03.08.2018]
 */
uiPlugins.set(dialog_1.ArbitraryFormDialog, function (component) { return new plugin_1.DialogMaterialPlugin(component); });
/**
 * @stable [29.05.2018]
 */
uiPlugins.set(form_1.FormDialog, function (component) { return new plugin_1.DialogMaterialPlugin(component); });
/* @stable - 31.03.2018 */
uiPlugins.set(menu_1.Menu, function (component) { return new plugin_1.MenuMaterialPlugin(component); });
/**
 * @stable [05.05.2018]
 */
uiPlugins.set(card_1.Card, function (component) { return new plugin_1.MaterialPlugin(component, ripple_1.MDCRipple); });
/**
 * @stable [08.05.2018]
 */
uiPlugins.set(keyboard_1.KeyboardKey, function (component) { return new plugin_1.MaterialPlugin(component, ripple_1.MDCRipple); });
di_1.appContainer.bind(di_1.DI_TYPES.UIPlugins)
    .toConstantValue(uiPlugins);
/**
 * @stable [27.05.2018]
 */
di_1.appContainer.bind(di_1.DI_TYPES.UIFactory).to(factory_1.UIMaterialFactory).inSingletonScope();
// TODO
require("../icon/icon-factory/default/ui-default-icon-factory.module");
/**
 * @stable [27.05.2018]
 */
util_1.addClassNameToBody('mdc-typography');
//# sourceMappingURL=material.module.js.map