/// <reference types="react" />
import { IMenuState, IMenuProps, IMenu } from './menu.interface';
import { BaseComponent } from '../base';
export declare class Menu extends BaseComponent<Menu, IMenuProps, IMenuState> implements IMenu {
    static defaultProps: IMenuProps;
    private fieldRef;
    private menuAnchorRef;
    /**
     * @stable [31.07.2018]
     * @param {IMenuProps} props
     */
    constructor(props: IMenuProps);
    /**
     * @stable [07.06.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [04.10.2018]
     */
    show(): void;
    /**
     * @stable [29.11.2018]
     */
    hide(): void;
    /**
     * @stable [29.11.2018]
     * @returns {boolean}
     */
    isOpen(): boolean;
    /**
     * @stable [06.08.2018]
     * @returns {IMenuItemEntity[]}
     */
    private readonly menuItems;
    /**
     * @stable [17.10.2018]
     * @param {IBasicEvent} event
     */
    private onCloseAction;
    /**
     * @stable [04.10.2018]
     * @param {string} filter
     */
    private onInputChange;
    /**
     * @stable [07.06.2018]
     * @returns {IField}
     */
    private readonly field;
    /**
     * @stable [06.08.2018]
     * @param {IBasicEvent<HTMLElement>} event
     * @param {IMenuItemEntity} option
     */
    private onSelect;
    /**
     * @stable [11.12.2018]
     * @returns {JSX.Element}
     */
    private readonly listElement;
    private getMenuItemElement;
}
