/// <reference types="react" />
import { BaseComponent } from '../base';
import { ITabPanelState, ITabPanel } from './tabpanel.interface';
import { ITabPanelProps } from '../../props-definitions.interface';
export declare class TabPanel extends BaseComponent<TabPanel, ITabPanelProps, ITabPanelState> implements ITabPanel {
    static defaultProps: ITabPanelProps;
    /**
     * @stable [11.08.2018]
     * @param {ITabPanelProps} props
     */
    constructor(props: ITabPanelProps);
    /**
     * @stable [02.09.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [04.10.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * Each plugin may implement this method
     * @stable [15.08.2018]
     */
    onForward(): void;
    /**
     * Each plugin may implement this method
     * @stable [15.08.2018]
     */
    onBackward(): void;
    /**
     * @stable [14.08.2018]
     * @param {ITabConfiguration} tab
     */
    private onTabClick;
    /**
     * @stable [02.09.2018]
     */
    private onDeactivateValue;
    /**
     * @stable [04.10.2018]
     * @param {ITabConfiguration} tab
     * @param {number} index
     * @returns {JSX.Element}
     */
    private getTabElement;
    /**
     * @stable [02.09.2018]
     * @returns {number}
     */
    private readonly activeValue;
}
