"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../../base/vue-index");
var vue_cyclic_viewer_interface_1 = require("./vue-cyclic-viewer.interface");
var util_1 = require("../../../util");
var VueCyclicViewer = /** @class */ (function (_super) {
    __extends(VueCyclicViewer, _super);
    function VueCyclicViewer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [29.01.2019]
     * @returns {boolean}
     */
    VueCyclicViewer.prototype.isPreviousStepAvailable = function () {
        return this.getIndex() > 0;
    };
    /**
     * @stable [29.01.2019]
     * @returns {boolean}
     */
    VueCyclicViewer.prototype.isNextStepAvailable = function () {
        return this.getIndex() < this.getList().length - 1;
    };
    /**
     * @stable [29.01.2019]
     */
    VueCyclicViewer.prototype.onPrevious = function () {
        this.getData().index--;
    };
    /**
     * @stable [29.01.2019]
     */
    VueCyclicViewer.prototype.onNext = function () {
        this.getData().index++;
    };
    /**
     * @stable [29.01.2019]
     * @returns {boolean}
     */
    VueCyclicViewer.prototype.isPdfFile = function () {
        return util_1.isPdfFileFormat(this.getFormat());
    };
    /**
     * @stable [29.01.2019]
     * @returns {boolean}
     */
    VueCyclicViewer.prototype.isImageFile = function () {
        return util_1.isImageFileFormat(this.getFormat());
    };
    /**
     * @stable [29.01.2019]
     * @returns {boolean}
     */
    VueCyclicViewer.prototype.hasFiles = function () {
        return this.getList().length > 0;
    };
    /**
     * @stable [29.01.2019]
     * @returns {string}
     */
    VueCyclicViewer.prototype.getSrc = function () {
        return this.getPayload().url;
    };
    /**
     * @stable [29.01.2019]
     * @returns {string}
     */
    VueCyclicViewer.prototype.getFormat = function () {
        return this.getPayload().format;
    };
    /**
     * @stable [29.01.2019]
     * @returns {IVueCyclicViewerPayloadEntity}
     */
    VueCyclicViewer.prototype.getPayload = function () {
        return this.getList()[this.getIndex()];
    };
    /**
     * @stable [29.01.2019]
     * @returns {number}
     */
    VueCyclicViewer.prototype.getIndex = function () {
        return this.getData().index;
    };
    /**
     * @stable [29.01.2019]
     * @returns {string}
     */
    VueCyclicViewer.prototype.getIndexInfo = function () {
        return this.getIndex() + 1 + "/" + this.getList().length;
    };
    /**
     * @stable [29.01.2019]
     * @returns {IVueCyclicViewerPayloadEntity[]}
     */
    VueCyclicViewer.prototype.getList = function () {
        return this.list || [];
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Array)
    ], VueCyclicViewer.prototype, "list", void 0);
    VueCyclicViewer = __decorate([
        vue_index_1.ComponentName(vue_cyclic_viewer_interface_1.VUE_CYCLIC_VIEWER_NAME),
        vue_property_decorator_1.Component({
            data: function () { return ({
                index: 0,
            }); },
            template: "\n      <vue-flex-layout class=\"vue-cyclic-viewer\">\n          <vue-flex-layout v-if=\"!hasFiles()\"\n                           :justifyContentCenter=\"true\"\n                           :alignItemsCenter=\"true\">\n            No files\n          </vue-flex-layout>\n          <vue-flex-layout v-if=\"hasFiles()\"\n                           class=\"vue-cyclic-viewer-content\">\n              <vue-pdf-preview v-if=\"isPdfFile()\"\n                               :src=\"getSrc()\"/>\n              <vue-picture-preview v-if=\"isImageFile()\"\n                                  :src=\"getSrc()\"/>\n          </vue-flex-layout>\n          <vue-flex-layout v-if=\"hasFiles()\"\n                           class=\"vue-cyclic-viewer-footer\"\n                           :justifyContentCenter=\"true\"\n                           :alignItemsCenter=\"true\">\n              <vue-flex-layout :row=\"true\"\n                               :full=\"false\"\n                               :alignItemsCenter=\"true\">\n                  <vue-button @click=\"onPrevious\"\n                              text=\"Previous\"\n                              :disabled=\"!isPreviousStepAvailable()\"/>\n                  <span class=\"vue-cyclic-viewer-index-info\">{{getIndexInfo()}}</span>\n                  <vue-button @click=\"onNext\"\n                              text=\"Next\"\n                              :disabled=\"!isNextStepAvailable()\"/>\n              </vue-flex-layout>\n          </vue-flex-layout>\n      </vue-flex-layout>\n  ",
        })
    ], VueCyclicViewer);
    return VueCyclicViewer;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-cyclic-viewer.component.js.map