import { AnyT } from '../definitions.interface';
/**
 * @stable [25.10.2018]
 * @param {AnyT} condition
 * @param {string | (() => string)} result
 * @returns {string}
 */
export declare const orEmpty: (condition: any, result: string | (() => string)) => string;
export declare function orNull<TResult>(condition: AnyT, result: TResult | (() => TResult)): TResult;
export declare function orUndef<TResult>(condition: AnyT, result: TResult | (() => TResult)): TResult;
/**
 * @deprecated
 */
export declare function orDefault<TResult1, TResult2>(cond: boolean, result1: TResult1 | (() => TResult1), result2: TResult2 | (() => TResult2)): TResult1 | TResult2;
/**
 * @deprecated
 */
export declare const ifNilReturnDefault: <TResult1, TResult2 = any>(checkedValue: any, result1: TResult1 | (() => TResult1), result2?: TResult2 | (() => TResult2)) => TResult1 | TResult2;
/**
 * @stable [01.12.2018]
 * @param {AnyT} checkedValue
 * @param {(() => TResult) | TResult} result
 * @returns {void | TResult}
 */
export declare const ifNotNilReturnValue: <TResult>(checkedValue: any, result: TResult | (() => TResult)) => TResult;
/**
 * @stable [19.08.2018]
 * @param {AnyT} value
 * @param {(() => TResult) | TResult} result
 * @returns {string | TResult}
 */
export declare const ifNilReturnUuid: <TResult>(value: any, result: TResult | (() => TResult)) => string | TResult;
/**
 * @stable [23.01.2018]
 * @param {TValue} value
 * @param {(value: TValue) => TResult} callback
 * @param {any} defaultValue
 * @returns {TResult}
 */
export declare const ifNotNilThanValue: <TValue, TResult>(value: TValue, callback: (value: TValue) => TResult, defaultValue?: any) => TResult;
